#!ruby -Imswin32
# AOT compiler test (benchmark)

require 'yarvutil'
require 'benchmark'

$line = __LINE__ + 3
###########################################################
$prog  =<<'__EOP__'
i=0
while i<100000000
  i+=1
end
__EOP__

$progc =<<'__EOP__'

compiled

__EOP__
###########################################################

puts YARVUtil.parse($prog, $0, $line).disasm
exit if ARGV[0] == 'po'

$lpback = $".dup

puts
puts "ruby\t" + Benchmark.measure{
  YARVUtil.eval_in_wrap($prog, $0, $line)
}.to_s
puts "yarv\t" + Benchmark.measure{
  YARVUtil.eval($prog, $0, $line)
}.to_s
puts "aotc\t" + Benchmark.measure{
  YARVUtil.eval($progc, $0, $line)
}.to_s
